% rubber: depend Graphics/outputs/stamp
\documentclass{llncs}
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage[pdftex]{graphicx}
\usepackage{url}
\usepackage{algorithm}
\usepackage{algorithmic}
\usepackage{color}
\usepackage{colortbl}
\usepackage{multirow}
\usepackage{multicol}
\usepackage{amsmath}

\def\TODO#1{\colorbox{yellow}{\bf TODO: #1}}

\newcommand{\R}{\textsuperscript{\textregistered}}
\newcommand{\TM}{\textsuperscript{\texttrademark}}

\begin{document}
%\title{An Efficient and Portable Generic Library for ECC Polar Codes
%Processing}
\title{An Efficient, Portable and Generic Library for Successive 
Cancellation Decoding of Polar Codes}
\titlerunning{Generic Polar Codes Processing}

\author{Adrien Cassagne\inst{1,2}
\and Bertrand Le Gal\inst{1} \and Camille Leroux\inst{1} 
\and Olivier Aumage\inst{2} \and Denis Barthou\inst{2}}
\authorrunning{A. Cassagne et al.}

\institute{IMS, Univ. Bordeaux, INP, France\\
\email{first.last@ims-bordeaux.fr}
\and Inria /  Labri, Univ. Bordeaux, INP, France\\
\email{first.last@inria.fr}}

\maketitle

% abstract 70 -- 150 words
\begin{abstract}
Error Correction Code decoding algorithms for consumer products such as
\emph{Internet of Things} (IoT) devices are usually implemented as
dedicated hardware circuits. As processors are becoming increasingly
powerful and energy efficient, there is now a strong desire to perform 
this processing in software to reduce production costs and time to 
market. The recently introduced family of Successive Cancellation 
decoders for Polar codes has been shown in several research works to 
efficiently leverage the ubiquitous SIMD units in modern CPUs, while 
offering strong potentials for a wide range of optimizations. The P-EDGE 
environment introduced in this paper, combines a specialized skeleton 
generator and a building blocks library routines to provide a generic, 
extensible Polar code exploration workbench. It enables ECC code 
designers to easily experiments with combinations of existing and new 
optimizations, while delivering performance close to state-of-art 
decoders.

\keywords{Error Correction Codes, Polar Codes, Successive Cancellation 
  decoding, Generic programming, Code generation, 
  Domain Specific Language, SIMDization}
\end{abstract}

\section{Introduction}

Error correction coding aka channel coding is a technique that enables 
the transmission of digital information over an unreliable communication 
channel. In today's communication systems, hardware digital circuits are 
in charge of performing the encoding (resp. decoding) of transmitted 
(resp. received) information. These custom Error Correction Code (ECC) 
circuits lack flexibility and suffer from very long, expensive 
development cycles. In order to improve the system flexibility and to 
reduce time to market, and as a consequence from the strong performance
increase of low power general purpose processors such as found in IoT 
devices, researchers recently suggested implementing channel decoders in 
software. Moreover, it is also much needed to be able to run such 
algorithms on high end, high performance processors to shorten the 
computationally intensive algorithm validation process. During such a 
process, long sequences of information are encoded with the studied 
algorithm, altered with a controlled random noise, decoded, and compared 
with the initial sequence to assess the error correcting power. Indeed, 
some classes of decoding algorithms can take advantage of modern CPU 
features such as SIMD units, and even many/multi-cores, making the 
software approach even more desirable.

In this paper, we focus on the software implementation of Successive
Cancellation (SC) decoder for a recent family of error correction codes:
Polar Codes \cite{arikan2009}. As an alternative to hardware 
implementation, several software implementations were proposed in the 
literature in order to demonstrate that polar codes decoding can be 
efficiently implemented on a multi-core CPUs (x86, ARM). These software 
implementations take advantage of various optimizations that were first 
proposed for hardware implementations. However, depending on the 
processor micro-architecture and instruction set, some optimization 
techniques may not work equally on distinct processors. New optimization 
techniques may be designed. Some optimization combinations may be less 
successful than others. As a result, the optimization space of polar 
decoder implementations is wide, and its exploration non trivial.

For this reason, we propose a new polar decoder experimentation
framework named P-EDGE (Polar ECC Decoder Generation Environment), which
combines a specializing skeleton generator with a building block library
of elementary polar code processing routines. The algorithm-centric
skeleton generator is fully independent from the hardware architecture
enabling high-level algorithmic optimization to be implemented in a
portable manner. The architecture-centric building block library is
fully independent from the generated skeleton instance, enabling
architecture porting effort and low-level routine optimization to be
concentrated on a small set of short functions. P-EDGE enables
separation of concern between algorithmic and architecture
optimizations. The panel of evaluation experiments we conducted shows
the high flexibility of our framework. The performance evaluation
results we obtained, nearing and sometime outperforming state-of-the-art
handwritten implementations, confirm that the benefit from this high
flexibility is not cancelled by an expensive penalty.

The remainder of this paper is organized as follows.
Section~\ref{sec:context} details the context and relevant
characteristics of the general polar code decoding process, as well as
the large optimization space resulting from its implementation.
Section~\ref{sec:contrib} presents our proposed framework as well as the
architecture independent skeleton generator. Section~\ref{sec:implem}
provides implementation details on the architecture dependent building
blocks. Section~\ref{sec:related} talks about the achieved related works 
in the domain. Section~\ref{sec:eval} shows experiments and 
performance results. Section~\ref{sec:conclusion} concludes this talk.

\section{Successive Cancellation decoding of Polar Codes}\label{sec:context}

Error correction codes are widely used in digital communication or data 
storage applications. The encoding process consists in adding some 
redundant information (parity check bits) in order to strengthen the 
message against transmission errors. On the receiver side, the decoder 
estimates the transmitted bits based on i) the received sequence and ii) 
the knowledge of the encoding process.
Polar Codes were recently proposed in \cite{arikan2009}. 
Similar to state of the art LDPC codes
~\cite{robert1963}
~\cite{david1999} and Turbo codes~\cite{berrou1993}, 
polar codes can achieve very good error correction performance. However, 
a very large codelength ($N>2^{20}$) is required in order to approach to 
the theoretical error correction limit proved by Shannon 
\cite{shannon1948}. The challenge is then to design polar codes decoders 
able to decode several millions bits frames while guaranteeing a 
compelling throughput.
Assume we want to transmit $K$ bits over a noisy communication channel. 
The encoding process appends $N-K$ parity check bits before the 
resulting $N$ bits codeword can be transmitted over the channel. On the 
receiver side, the noisy sequence $Y$ is a vector of $N$ real values 
each corresponding to \textit{a priori} beliefs on the transmitted bits. 
These beliefs are in the form of a Log-Likelihood-Ratio (LLR). Using the 
knowledge of the encoding process, the decoder job is to estimate the 
transmitted $N$-bit codeword based on a received sequence of $N$ LLRs.

\begin{figure}[htp]
\centering
\includegraphics[width=0.55\textwidth]{Diagrams/data_representation_SC_decoder}
\hspace{0.5cm}
\includegraphics[width=0.35\textwidth]{Diagrams/3_nodes}
\caption{a) Tree layout. b) Per-node downward and upward computations.}
\label{fig:sc_data}
\label{fig:3_nodes}
\end{figure}

The SC decoding algorithm can be seen as the traversal of a binary tree 
starting from the root node. For a codelength $N=2^m$, the corresponding 
tree thus includes $m + 1$ node layers, indexed from $l=0$ (root node 
layer) down to $l=m$ (leaf nodes layers). As the tree is initially full, 
each layer $l$ contains $2^l$ nodes, each node of that layer $l$ 
containing $2^{m-l}$ LLRs ($\lambda$) and $2^{m-l}$ binary values 
denoted as \textit{partial sums} ($s$). At initialization, LLRs received 
from the channel ($Y$) are stored in the root node. Then, the decoder 
performs a pre-order traversal of the tree. When a node is visited in 
the downward direction, LLRs of the node are updated. In the upward 
direction, partial sums are updated. Fig.~{\ref{fig:3_nodes}b} 
summarizes the computations performed in both directions. The update 
functions are:
\begin{eqnarray}
\left\{\begin{array}{l c l c l}
\lambda_c &=& f(\lambda_a,\lambda_b) &=& sign(\lambda_a.\lambda_b).\min(|\lambda_a|,|\lambda_b|)\\
\lambda_c &=& g(\lambda_a,\lambda_b,s)&=&(1-2s)\lambda_a+\lambda_b\\
(s_{c}, s_{d}) &=& h(s_{a}, s_{b}) &=& (s_{a} \oplus s_{b}, s_{b}).
\end{array}\right.
\label{eq:f_g}
\end{eqnarray}
The $f$ and $g$ functions both generate a single LLR. The $h$ function 
provides a couple of partial sums.

Before recursively calling itself on the left node, the algorithm apply 
the $f$ function, respectively, before calling itself on the right node 
the $g$ function is applied. At the end (after the recursive call on the 
right node) the $h$ function is applied. 
The $f$ and $g$ functions use the LLRs (read only mode) from the current 
node in order to produce the new LLR values into respectively left and 
right nodes. The $h$ function, in the general case (non-terminal case), 
reads the bits from the left and right node in order to update the bit 
values of the current nodes. For the terminal case, the $h$ function 
reads the LLRs from itself and decides the bit values.

Leaf nodes are of two kinds: \emph{information bit} nodes and 
\emph{frozen bit} nodes. When a frozen bit leaf node is reached, its 
binary value is unconditionally set to zero. Instead, when an 
information leaf node is reached, its binary value is set according to 
the \emph{sign} of its LLR (0 if LLR is positive, 1 otherwise). Once 
every node in the tree has been visited in both directions, the decoder 
eventually updates partial sums in the root node and the decoding 
process is terminated. At this point, the decoding result is stored in 
the root node in the form of a $N$-bit partial sum vectors.

\subsection{Code Optimization Space}

The previous decoder algorithm has a number of characteristics of
interest for its optimization. Generating decoders able to take
advantage of this optimization space is the key for high performance
decoders:
\begin{itemize}
\item The tree traversal is sequential, but $f$, $g$ and $h$ are applied element-wise to all elements 
  of the LLR and bits in the nodes and their children. As there is
  no dependence between computations involving different elements of
  the same node, these node computations can be parallelized or
  vectorized 
  (cf. the \emph{intra-frame} strategy introduced in \cite{giard2014}),
\item Frozen bits fully define their leaf values, hence some part of the 
  traversal can be cut and its computation avoided, depending on the 
  location of the frozen bits. More generally, the tree computation can 
  be versioned depending on these bits 
  (cf. \cite{alamdar-yazdi2011}~\cite{sarkis2014_1}),
\item The decoder can be specialized for a particular
  configuration of frozen bits, as frozen bit locations do not change for many frames. 
\item Similarly, multiple frames can be decoded concurrently,
  with parallel or vector code. Such \emph{inter-frame} optimizations 
  can increase the decoding throughput, however at the expense of 
  latency, which is also one important metric of the application 
  (cf. \cite{le-gal2015}).
\end{itemize}

Beside optimizations coming from the computations in the tree, several
representations of LLR may lead to different error correction 
performance. LLR for instance can be represented by floats or integers 
(fixed point representation), LLR from different frames can be packed 
together.

Finally, usual code optimizations, such as unrolling or inlining can
also be explored. For instance, the recursive structure of the tree
computation can be fully unrolled, depending on the size of the
codelength.

\section{The P-EDGE framework}
\label{sec:contrib}

We now presents the framework we designed to study, experiment with, and
optimize the decoding of \emph{polar codes}. While our contributions 
focus on the decoding stage, a whole encoding/decoding chain is required 
for testing and validation purpose, and we therefore give an 
overview of our communication chain.

\subsection{Overview}

\begin{figure}[htp]
\centering
\includegraphics[width=1.00\textwidth]{figs/communication_chain}
\caption{The communication chain.}\label{diagram:communication_chain}
\end{figure}

Fig.~\ref{diagram:communication_chain} depicts the whole communication
chain of our framework. The chain stages are organized as the following 
main segments:

The \textbf{Transmitter} segment is made of two Stages: 1) The source 
signal generator stage (\emph{Source}) produces the vector of 
information bits $U_K$ to be transmitted. 2) The polar encoding stage 
(\emph{Encoder}) inserts parity check redundancy bits into information 
vector. For every packet of $K$ information bits, a total of $N$ bits 
are produced (information+redundancy bits). The resulting N-bit vector 
($X_N$) is transmitted over the communication channel.

The \textbf{Communication channel} segment simulates a noisy 
communication, adding additive white Gaussian noise to the frames, 
producing the real vector $Y_N$ from the binary vector $X_N$. 

The \textbf{Receiver} segment is made of two Stages: 1) The
\emph{Decoder} stage produces a binary vector $V_N$ from $Y_N$ along
using the algorithm described above. 2) The \emph{Sink} stage
eventually compares the K information bits ($V_K$) in $V_N$ with $U_K$ in order 
to count the number of remaining binary errors after the decoding is 
performed. The more effective the error correction code is, the closer 
the $V_K$ bits should be from the $U_K$ bits. Resilient errors may come 
from 1) inherent limitations in the polar code construction, 
2) sub-optimal decoding algorithm, 3) a high noise power in the 
communication channel. Moreover, while testing new algorithm 
implementations or optimizations, an abnormally high error rate can also 
be the sign of a bug.

\subsection{The P-EDGE Decoder Generator}
\label{sec:generator}

\begin{figure}[htp]
\centering
\includegraphics[width=1.0\textwidth]{figs/patterns}
\caption{Subtree rewriting rules for processing specialization.}
\label{diagram:patterns}
\end{figure}

\paragraph{Specialized Decoder Skeletons and Building Blocks Library.} 
The tree structure at the heart of SC decoders is fully determined by 
the parameters of a given code instance: the code size, the code rate 
($R = K / N$), position of the frozen bits. All these parameters are 
statically known at compile time. Thus, the recursive tree traversal 
code structure and the corresponding tree data structure are challenging 
to optimize and vectorize for a compiler. Our Polar ECC Decoder 
Generation Environment (P-EDGE) builds on this property to provide a 
general framework for polar decoder design, generation and optimization. 
Beyond the \emph{code parameters}, Polar decoders can be tweaked and 
optimized in many different orthogonal or loosely coupled ways: 
\emph{Elementary} type (floating point, fixed point), 
\emph{Element containers} (array size), \emph{Data layout} (bit packing
techniques), \emph{Instruction Set} (x86, ARM), \emph{SIMD} support
(scalar, intra-frame or inter-frame processing
vectorization), \emph{SIMD instruction set variant} (SSE, AVX, NEON), as
well as the set and relative priorities of the \emph{rewriting rules for
tree pruning}. Our framework enables to quickly experiment
the different combinations of all optimizations. The decoder code thus 
results from two distinct parts: 
\begin{itemize}
\item An architecture independent \emph{specialized decoder skeleton} 
  generated by our decoder generator, from a given frozen bits location 
  input. Starting from the naive, recursive expression of the 
  computational tree, we apply successively cuts and specializations on 
  the tree. They are described through a set of rewriting rules, that 
  can be customized according to the specificities of the decoder and to 
  the constraints in term of code size for instance.
\item A library of architecture dependent \emph{elementary computation 
  building blocks}, corresponding to the implementation variants of the 
  $f$, $g$ and $h$ functions (fixed or floating point versions, scalar 
  or vector versions, ...). These blocks do not depend on the frozen 
  bits location and can therefore be used by any specialized skeleton.
\end{itemize}

This separation of concerns between high-level specialized algorithmic
skeletons and low-level arithmetic routines, enables both ECC experts to
focus on optimizing algorithm skeletons and architecture experts to 
focus on writing highly optimized routines, without interferences.

\begin{figure}[htp]
\begin{minipage}{0.64\textwidth}
\includegraphics[width=\textwidth]{figs/patterns_example}
\end{minipage}
\begin{minipage}{0.35\textwidth}\tiny\begin{verbatim}
void Generated_SC_decoder_N8_k4::decode() 
{
  f  <   R, F, FI, 0, 4,    8, 4>::apply(l   );
  rep<B, R, H, HI, 8,       0, 4>::apply(l, s);
  gr <B, R, G, GI, 0, 4, 0, 8, 4>::apply(l, s);
  spc<B, R, H, HI, 8,       4, 4>::apply(l, s);
  xo <B,    X, XI, 0, 4,    0, 4>::apply(   s);
}
\end{verbatim}
\end{minipage}
\caption{Generation process on a small binary tree ($N = 8$). The tree 
  is cut and the computations are versioned according to the location of 
  the frozen bit. The final code generated is in the right.}
\label{diagram:patterns_example}
\label{fig:patterns_example}
\end{figure}

\paragraph{Decoder Generation.} The decoder generator first builds the 
binary tree structure as shown in Fig.~\ref{fig:sc_data}a from the 
frozen bit location input. Each internal node has a tag indicating the 
the type of processing required at that node (recursive 
children processing, $f$/$g$/$h$ functions to be applied or not). This 
tag is initially set to \emph{default}, corresponding to the canonical
processing described in Fig.~{\ref{fig:3_nodes}b}.

For some sub-tree pattern configurations, the processing to be performed
at the root of such sub-trees can be simplified, or even skipped
completely, for instance when a node only has two frozen bit leaf
children. To exploit such properties, the decoder generator repeatedly 
applies the set of sub-tree rewriting rules listed in
Fig.~\ref{diagram:patterns} using a depth first traversal to alter the
node tags, until no rewriting rule applies anymore.

Each rewriting rule defines a subtree pattern \emph{selector}, a new
\emph{tag} for the subtree root, and the $f$, $g$, and $h$
\emph{processing functions} to be applied, simplified or skipped for
this node in the resulting decoder. A \emph{null} $f$ (resp. $g$)
function cuts the left (resp. right) child of the node.
From an implementation point of view, a rule is defined as a class,
with a \texttt{match} function, and a set of functions $f$, $g$, and 
$h$. The current set of rewriting rules can thus easily be enriched with 
new rules to generate even more specialized versions.

Patterns on the first two rows result in cutting away both children. For
instance, the first rule, named \emph{Rate~0, leaf children}, cuts the 
two frozen bit leaf children of the parent node, and tag it as 
\emph{Rate~0} (white node). Processing is completely skipped on this 
node since the values of the bits are unconditionally known. The 
\emph{Repetition} rules match subtrees where only the rightmost leaf is 
black (tag \emph{Rate~1}), the others being frozen bits. In this case, 
the whole subtree is cut and replaced by a more simple processing. 
Moreover a single, specialized $rep$ function is applied on the node 
instead of the three functions $f$, $g$ and $h$. The third line 
describes partial cuts and specialization. For instance, the rule 
``Repetition 1, left only'' specializes the $g$ and $h$ functions to 
use, but does not prune the recursive children processing.

Rewriting rules are ordered by priority (left to right, then top row to
bottom row in Fig.~\ref{diagram:patterns}), thus if more than one rule
match an encountered subtree, the highest priority rule is applied. The
priority order is chosen such as to favor strongest computation reducing
rules over rules with minor impact, and to ensure confluence by
selecting the most specific pattern first. Rules selectors can match on
node tags and/or node levels (leaf, specific level, above or below some
level). A given rule is applied at most once on a given node.

Finally, once the tree has been fully specialized, the generator perform
a second tree traversal pass to output the resulting decoder. An example
of such a tree specialization process together with the generator output 
is shown in Fig.~\ref{fig:patterns_example}.

\section{Low Level Building blocks}
\label{sec:implem}

\begin{figure}[ht]
\begin{minipage}{0.475\textwidth}\scriptsize
\begin{verbatim}
template <typename R>
R f_seq(const R& la, 
        const R& lb)
{
  auto abs_la  = (la >= 0) ? la : -la;
  auto abs_lb  = (lb >= 0) ? lb : -lb;
  auto min_abs = std::min(abs_la, abs_lb);
  auto sign    = (0 < la*lb) - (la*lb < 0);
  auto lc      = (R)sign * min_abs;
	
  return lc;
}
\end{verbatim}
\end{minipage}
\begin{minipage}{0.525\textwidth}\scriptsize
\begin{verbatim}
template <typename R>
mipp::vec f_simd(const mipp::vec& la, 
                 const mipp::vec& lb)
{
  auto abs_la  = mipp::abs <R>(la             );
  auto abs_lb  = mipp::abs <R>(lb             );
  auto min_abs = mipp::min <R>(abs_la,  abs_lb);
  auto sign    = mipp::sign<R>(la,      lb    ); 
  auto lc      = mipp::neg <R>(min_abs, sign  );

  return lc;
}
\end{verbatim}
\end{minipage}
\caption{Example of the C++ implementation of the $f$ function in P-EDGE 
  (the sequential version is in the left whereas the SIMD one is in the 
  right).}
\label{fig:f_implementation}
\end{figure}

The main challenge in implementing P-EDGE's architecture dependent
building blocks is to provide enough flexibility to enable varied type,
data layout and optimization strategies such as intra-frame SIMDization
(intra-SIMD) and inter-frame SIMDization (inter-SIMD), without breaking
the high level skeleton abstraction. To meet this requirement, our
building block library heavily relies on generic programming and compile
time specialization by the means of C++ templates, in a manner inspired
by \emph{expression template} techniques \cite{stroustrup2013}.
Template specializations provide node functions.
Fig.~\ref{fig:patterns_example} gives a example of a generated decoder
for $N = 8$, calling template instances of the node functions.
\texttt{B}:~partial sum type; \texttt{R}: LLR/$\lambda$ type;
\texttt{F}/\texttt{G}/\texttt{H}/\texttt{X}: Scalar standard SC function
versions; \texttt{FI}/\texttt{GI}/\texttt{HI}/\texttt{XI} SIMD versions.
Remaining template parameters are offsets and chunk sizes to control
data layout.

A single SIMD set is needed because \emph{SIMD routines are common to
both intra-SIMD and inter-SIMD}. In the later case, the generated
decoder packs as many frames together from the frame stream as the
vector size in a transparent manner. In both cases, offsets are fully
precomputed at compile time. \textbf{Intra-SIMD} exploits SIMD units
without increasing the decoder latency, since it still processes frames
one at a time and thus preserves fine grain frame pipelining. However,
at leaf nodes and nearby, too few elements remain to fill SIMD units.
For instance, 4-way SIMD registers are fully filled only at level 2 and
above. Thus, Intra-SIMD will only be effective on trees that can be
heavily pruned from these numerous scalar nodes. \textbf{Inter-SIMD}
does not suffer from this problem, since SIMD register lanes are filled
by LLRs and bits from multiple frames instead. However, the decoder 
needs to wait for enough frames to arrive, which increases latency, and 
to interleave the LLRs from these frames (\emph{gather}) before 
proceeding. It also needs to de-interleave the resulting data (the bits) 
after decoding (\emph{scatter}). Refer to \cite{le-gal2015} for more 
details about the interleaving process.

The framework instantiates scalar or SIMD functions as appropriate
(hence the two sets of functions). These two sets of 
functions are themselves \emph{independent on the element type}. Scalar
functions are datatype-parametered templates. SIMD functions use the
template-based MIPP intrinsics wrapper library developed by one of the
authors to benefit from SSE, AVX and NEON flavors SIMD instruction sets
in a portable and extensible manner. As an example, the generic scalar
and SIMD implementations of the $f$ function are shown in
Fig.~\ref{fig:f_implementation}.

The decoder stores its state using two data buffers, one for the LLR
values ($\lambda$) and the other for the bits (partial sums $s$). The
``logical'' tree layout is implemented as a simple and efficient
\emph{heap} vector data layout. Traversing the tree therefore
corresponds to moving through the array, at different offsets and
considering different index intervals. The LLR
offset is computed from the graph depth~$d$ (or the node vertical 
indexing) as follows:
\begin{equation}
  off_{\lambda}(d) = \begin{cases}
                 0                                         &\text{$d = 0$},\\
                \sum\limits_{i = 1}^{d} \frac{N}{2^{i-1}} &\text{otherwise.}
\end{cases}
\end{equation}
Given~$l$ the lane (or the node horizontal indexing), the bit offset is 
determined as follows:
\begin{equation}
  off_{s}(d,l) = \frac{N}{2^d} \times l.
\end{equation}
The LLR buffer size is $2N$ and the bit buffer is $N$, for a frame of
$N$ bits. Thus, the memory footprint per frame is:
\begin{equation}
	mem_{fp} = N \times (2 \times sizeof(LLR) + sizeof(bit)).
\end{equation}
LLRs element size is 4 bytes (float) or 1 byte (fixed point numbers). 
The Inter-SIMD version also employs a \emph{bit packing} memory
footprint reduction technique~\cite{le-gal2015} to pack several
bits together by using shifts and masking instructions.

\section{Related works}
\label{sec:related}

Polar codes \cite{arikan2009} keep on gaining attention from circuits
and systems designers. The practical interest of these codes comes from
the possibility to implement them efficiently in software. Software
implementations were proposed in \cite{giard2014} on x86 processor
targets, using SIMD instructions to speed-up single frame decoding
(intra-frame parallelism). In addition to SIMD optimizations, the tree
pruning step described in section \ref{sec:contrib} was also applied to
the decoder in \cite{sarkis2014_1}. Moreover, fixed point representation
was implemented in order to speed up the decoding process. This
modification of the data format has a negligible impact on error
correction quality while enabling better throughput. The authors
proposed to improve the throughput performance by auto-generating the
source code of their floating point decoders \cite{sarkis2014_2}.
A second set of works \cite{le-gal2015} has considered an another way to
take advantage of SIMD processing capabilities. Authors focused on
inter-frame parallelism using both SIMD and multi-thread
parallelization. Indeed, this approach enables constant parallelism
level during the overall decoding process, at the cost of an increased
latency. Throughputs achieved using this approach and the associated
implementation optimizations were about $\times 4$ to $\times 8$ times
higher than \cite{giard2014}. An ARM-based implementation was also
explored in \cite{le-gal2014} to enable low power consumption software
decoding for a potential use on consumer devices.

The P-EDGE philosophy differs from these previous approaches by
promoting separation of concerns and genericity as first class
objectives to enable experimenting with multiple optimization
strategies. Results presented in Section~\ref{sec:eval} show that
these objectives are not incompatible with performance.

Concerning automatic generation of high performance libraries, ATLAS
generator \cite{atlas}, LGen \cite{lgen} and SPIRAL \cite{spiral} are
examples for linear algebra libraries and signal processing domains,
all resorting to autotuning to find the best version. LGen and SPIRAL
generate optimized code from a Domain Specific Language (DSL). A
different generative approach is adopted by Eigen \cite{eigen} or
uBLAS \cite{boost}. While Eigen focuses on structural recursion, it is
applied to matrices and not to trees. They use C++ templates to
optimize the code at compile time.  Comparatively, the technique
presented in this paper combines the two generative approaches: the
generator produces code from an initial formulation, optimized by
rewriting rules. The second step also optimizes code from C++ templates. 

%\begin{enumerate}
%  \item Discuss related work on ECC Polar Codes implementations
%    (McGill papers, and other papers if exists)\\
%    MacGill optimizations listing:
%    \begin{enumerate}
%      \item Special subtree cases optimization and cuts:
%      \begin{itemize}
%        \item rate 0 cut (only frozen bits),
%        \item rate 1 cut (only information bits),
%        \item repetition codes,
%        \item single parity check codes,
%        \item use of the maximum-likelihood (ML is a brute force 
%          method) decoder at the end of the tree.
%      \end{itemize}
%    \item Data representation : single-precision floating-point values 
%      (in \cite{sarkis2014_2})
%    \item Intra frame vectorization only
%    \item They don't have bit packing because this is not relevant in 
%      intra frame
%    \item Inlining and unrolling are done by the compiler (there is no 
%      such thing as manual unrolling with the C++ templates)
%  \end{enumerate}
%  \item Discuss related works in computer science for similar problems
%    (DSL+code generator, template libraries, auto-tuned libraries:
%    fftw, spiral, atlas, etc.)
%\end{enumerate}

\section{Evaluation}
\label{sec:eval}

In this section we first describe the protocol we used, after that we 
provide a performance comparison between the state-of-the-art and 
P-EDGE. At the end we discuss the exploring capabilities of our 
framework.

\begin{table}[ht]
\begin{center}
{\scriptsize
\begin{tabular}{c|c|c|c}
         & x86-based              & ARMv7-based             & prev. work arch.\cite{sarkis2014_2}\\
\hline
CPU      & Intel Xeon E31225      & ARM Cortex-A15          & Intel Core i7-2600                 \\
         & 3.10Ghz                & MPCore~2.32GHz          & 3.40GHz                            \\
Cache    & 32KB L1I/L1D, 256KB L2 & 32KB L1I/L1D, L2 1024KB & 32KB L1I/L1D, L2 256KB             \\
         & L3 6MB                 & No L3                   & L3 8MB                             \\
Compiler & GNU g++~4.8            & GNU g++~4.8             & GNU g++~4.8                        \\ 
\hline
% Flags for 32-bit& \texttt{-std=c++11 -Ofast -funroll-loops -mavx}\\
% Flags for 8-bit & \texttt{-std=c++11 -Ofast -funroll-loops -msse4.1}\\
\end{tabular}
}
\end{center}
\caption{Performance evaluation platforms.}\label{tab:platforms}
\end{table}

The platforms used for performance evaluation are shown in
Table~\ref{tab:platforms}. Unless stated otherwise, each measure is
obtained as the best of ten runs of a 10~second simulation, taking into
account frame loading and result storing. SNR (Signal Noise Ratio) is
set to 2.5~dB for tests with 1/5 and 1/2 rates, and to 4.0 dB for the
5/6, 0.84, and 9/10 rate tests. Colors differentiate the codes rates of 
the Polar Code, point shapes differentiate decoder types (Intra-SIMD vs 
Inter-SIMD).

\subsection{Comparison between P-EDGE and the State of the Art}

\begin{figure}[htp]
\includegraphics[width=1\textwidth]{Graphics/outputs/E31225_A15_thr_intra_32b}
\caption{Performance comparison between several code rates of 32-bit 
  floating point decoding stages (running on the Intel\R Xeon\R CPU 
  E31225 and, respectively, on the Nvidia\R Jetson TK1\R CPU A15).}
\label{plot:float32_intra_avx}
\end{figure}

\begin{table}[h]
\begin{center}
\begin{tabular}{c c c c}
  \hline 
  $(N, K)$                        & Decoder                       & Info T/P (Mb/s) & Latency ($\mu$s)\\
  \hline  
%%this performance is included in the graphs
% \multirow{2}{*}{(2048, 1024)}   & prev. work\cite{sarkis2014_2} & 147             & 7               \\
%                                 & this work                     & 195             & 5               \\
% \hline 
%%this performance is included in the graphs
% \multirow{2}{*}{(2048, 1707)}   & prev. work\cite{sarkis2014_2} & 335             & 5               \\
%                                 & this work                     & 402             & 4               \\
% \hline 
  \multirow{2}{*}{(16384, 14746)} & prev. work\cite{sarkis2014_2} & 292             & 50              \\
                                  & this work                     & 341             & 43              \\
  \hline 
  \multirow{2}{*}{(32768, 27568)} & prev. work\cite{sarkis2014_2} & 220             & 125             \\
                                  & this work                     & 241             & 114             \\
  \hline 
  \multirow{2}{*}{(32768, 29492)} & prev. work\cite{sarkis2014_2} & 261             & 113             \\
                                  & this work                     & 293             & 101             \\
  \hline 
\end{tabular}
\end{center}
\caption{Comparing P-EDGE with a state-of-art software polar decoder,
  for codes of rate 0.84 and rate 0.9, using Intra-SIMD. The two cross
  marks show state-of-the art performance results reported in
  \cite{sarkis2014_2}, for comparison.}
\label{tab:mcgill_vs_us}
\end{table}
\begin{figure}[htp]
\includegraphics[width=1\textwidth]{Graphics/outputs/E31225_A15_thr_inter_8b}
\caption{Performance comparison between several code rates of 8-bit
  fixed point decoding stages (running on the Intel\R Xeon\R CPU E31225
  and, respectively, on the Nvidia\R Jetson TK1\R CPU A15). Circles
  show P-EDGE results. Triangles show our former ``handwritten''
  implementation results~\cite{le-gal2015}.}
\label{plot:int8_inter_sse41}
\end{figure}

Fig.~\ref{plot:float32_intra_avx} shows P-EDGE intra-frame throughput on
different architectures. Our generic framework performance matches
previous work decoder results. This is confirmed in
Tab.~\ref{tab:mcgill_vs_us} which compares P-EDGE with the
state-of-the-art result samples for some specific rates reported in
\cite{sarkis2014_2}. The throughput of the inter-frame implementation is
shown in Figure~\ref{plot:int8_inter_sse41} for different architectures.
Again, the results confirm that our generic approach nears handwritten
code.

\begin{table}[h]
\begin{center}
\begin{tabular}{ c | c | c | c | c | c | c}
  Decoder                  & $N = 2^6$ & $N = 2^8$   & $N = 2^{10}$ & $N = 2^{12}$ & $N = 2^{14}$ & $N = 2^{16}$  \\
  \hline 
  inter 32-bit, $R = 1/2$  & 7         & 24          & \textbf{77}  & \textbf{254} & \textbf{736} & \textbf{2528} \\
  \hline 
  inter 32-bit, $R = 5/6$  & 4         & 19          & \textbf{53}  & \textbf{167} & \textbf{591} & \textbf{1758} \\
  \hline
  intra 32-bit, $R = 1/2$  & 4         & 16          & \textbf{56}  & \textbf{182} & \textbf{563} & \textbf{1947} \\
  \hline
  intra 32-bit, $R = 5/6$  & 3         & 13          & \textbf{38}  & \textbf{126} & \textbf{392} & \textbf{1365} \\
  \hline
  intra ~8-bit, $R = 1/2$  & 5         & 22          & \textbf{72}  & \textbf{252} & \textbf{665} & \textbf{2220} \\
  \hline
  intra ~8-bit, $R = 5/6$  & 4         & 18          & \textbf{51}  & \textbf{191} & \textbf{461} & \textbf{1555} \\
\end{tabular}
\end{center}
\caption{Code size (in KB) of the generated decoders depending on the 
  number of bits $N$ per frame (code respectively compiled with AVX1 
  instructions for the 32-bit decoders and with SSE4.1 instructions for 
  the 8-bit decoders).}
\label{tab:decoders_size}
\end{table}

For all the test series, the bandwidth first increases with codeword
size, as the tree pruning becomes increasingly more effective with
larger trees. The effect is stronger for Intra-SIMD where pruning also
results in removing inefficient scalar nodes. However, beyond a codeword
size point which depends on the architecture and on the selected SIMD
version, performance decreases again due to L1 cache misses, not only
L1D but L1I as well. Indeed, decoders are generated as straight-line
code (no recursive calls), with all node computations put in sequence.
This improves performance for small to medium codeword size, up to the
point where the compiled binary exceeds the L1I cache size. The
performance of the decoder is then governed by the code size, as can be
seen in Table~\ref{tab:decoders_size}. For all versions, on both ARM and
Intel architectures, the code size exceeds the 32KB of the L1I cache for
$N\geq2^{10}$. We intend to address this performance bottleneck in
future work, for instance by folding similar tree computation sequences
together. Nevertheless, comparing the performance of our generic decoder
framework with related works, the bottom line is that performance
obtained matches state-of-the art decoders, while preserving portability
and providing much more flexibility.

\subsection{Exploring respective optimization impacts with P-EDGE}

\begin{figure}[htp]
\includegraphics[width=\textwidth]{Graphics/outputs/E31225_thr_opti.pdf}
\caption{Throughput depending on the different optimizations for 
  $N = 2048$, for intra-frame vectorization on the left and intra-frame 
  vectorization on the right, resp.  (on the Intel\R Xeon\R CPU E31225).}
\label{plot:intra_inter_opti}
\end{figure}

The tree pruning step has a dramatical effect in general. For example,
the reference code for a rate of 1/2 has 2047 nodes, whereas only 205
nodes remain in the pruned version. However, the individual effect of
each rewriting rule is not trivial. The plots in Figure
\ref{plot:intra_inter_opti} show the respective impact of several
rewriting rules (cuts, repetitions, single parity checks (SPC)), with $N
= 2048$ and multiple code rates, for Intra-SIMD and Inter-SIMD
respectively. The purpose of the plots is to show that no single
rewriting rule dominates for every code rate, and that the respective
impact each rule may vary a lot from rate to rate, making the case for
the flexible, extensible architecture of P-EDGE. Indeed, P-EDGE's
rewriting rule set can also be enriched we rules for specific ranges
of code rate. For instance, the rule \emph{Single Parity Check (SPC)}
has been applied with different level limits for 9/10 code rate, where
it has a significant impact and may benefit from fine tuning.

\begin{figure}[htp]
\centering
\includegraphics[width=0.5\textwidth]{Graphics/outputs/E31225_thr_inter_intra_32b}
\caption{A focus on 32-bit floating point P-EDGE decoder instances
  performance on large codeword size, \emph{considering the decoding 
  time only} (on Intel Xeon CPU E31225).}
\label{plot:float32_inter_intra_avx}
\end{figure}

A comparison between the performance of the different decoder instances
obtained from the same code is shown in Figure
\ref{plot:float32_inter_intra_avx}. Only codeword sizes of more than
$2^8$ are shown, as smaller sizes are of little interest in practice.
One can see that for a given bit rate, \emph{the best version depends on
the codeword size}. Inter-SIMD dominates for a 1/2 rate, while
Intra-SIMD dominates for a 5/6 rate on code size larger than $2^{12}$.
This shows the interest of having both intra-frame and inter-frame SIMD
in the same framework.

\section{Conclusion and future works}\label{sec:conclusion}

In this paper, we have developed a framework that enable exploring
optimizations for Successive Cancellation decoders of the Polar Codes 
family while enforcing a clear separation of concerns between the
generic, abstract algorithmic level and the low-level architecture
dependent building block implementations. The benefits gains in terms of
software design and flexibility are not overshadowed by prohibitive
run-time performance results. On the contrary, the use of a specialized
skeleton generator to produce optimized compile-time decoders enables
performance levels to near, and even to match state of art
implementations.

Future work will in priority be dedicated to addressing the large
resulting executable binaries that may result from the code generation
stage. We intend to experiment with code folding techniques to merge
similar processing sequences. A more in-depth performance
analysis, for instance by applying the \emph{Roof-line}
model~\cite{williams2009} or even better the 
\emph{Execution-Cache-Memory} (ECM) model \cite{treibig2009}, would also 
give us much more insight about the remaining code optimization 
head-room, as the algorithm tend to be inherently memory bound. Finally, 
we intend to stress-test the genericity of our framework on other 
decoder variants from the Polar Codes family.

\section{Acknowledgements}

We wish to thank Guillaume Berhault for his participation to the 
Figure~\ref{fig:sc_data}a which have accelerated our work.

\nocite{*} % remove once we have a few references

\bibliography{biblio}
\bibliographystyle{splncs03}
\end{document}
% vim:sw=2:tw=72:et:spell:spelllang=en:
